Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:10 2011
FILE NAME: moistadjust.f90
PROGRAM NAME: moistadjust
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   102  opt  (  11): Fused array assignments. :line 102 - 113
   102  vec  (   4): Vectorized array expression.
   122  opt  (  11): Fused array assignments. :line 122 - 127
   122  vec  (   4): Vectorized array expression.
   129  vec  (   3): Unvectorized loop.
   134  vec  (   4): Vectorized array expression.
   134  vec  (   4): Vectorized array expression.
   137  vec  (   4): Vectorized array expression.
   137  vec  (   4): Vectorized array expression.
   143  vec  (   4): Vectorized array expression.
   143  vec  (   4): Vectorized array expression.
   149  opt  (  11): Fused array assignments. :line 149 - 166
   149  vec  (   4): Vectorized array expression.
   170  opt  (  11): Fused array assignments. :line 170 - 172
   170  vec  (   4): Vectorized array expression.
   170  vec  (   4): Vectorized array expression.
   218  opt  (  11): Fused array assignments. :line 218 - 237
   218  vec  (   4): Vectorized array expression.
   239  vec  (   3): Unvectorized loop.
   244  opt  (  11): Fused array assignments. :line 244 - 247
   244  vec  (   4): Vectorized array expression.
   244  vec  (   4): Vectorized array expression.
   256  opt  (  11): Fused array assignments. :line 256 - 278
   256  vec  (   4): Vectorized array expression.
   282  opt  (  11): Fused array assignments. :line 282 - 285
   282  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:10 2011
FILE NAME: moistadjust.f90
PROGRAM NAME: moistadjust
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module MoistAdjust
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4  ! Version::   $Id: moistadjust.f90,v 1.4 2011-06-03 06:11:22 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !˰Ĵˡ
    12  !
    13  !== Error Handling
    14  !
    15  !== Bugs
    16  !
    17  !== Note
    18  !
    19  !== Future Plans
    20  !
    21  !
    22  
    23  Module MoistAdjust
    24    !
    25    !˰ĴˡԤΥѥå⥸塼
    26    !  * ˰¾Ȥؼ, 층Ū˼¹Ԥ
    27    !  * ȿˤĤƤ, 줾βȿ˼¹Ԥ.
    28  
    29    !⥸塼ɤ߹
    30    use dc_types,   only : DP
    31    use dc_message, only : MessageNotify
    32    use gridset, only :    ncmax,                &!ؼο
    33      &                    imin, imax,        &!x ξ¤Ȳ
    34      &                    jmin, jmax,        &!y ξ
    35      &                    kmin, kmax          !z β
    36    use basicset,only :    xyz_ExnerBZ,       &!̵(ܾ)
    37      &                    xyz_PTempBZ,       &!(ܾ)
    38      &                    xyzf_QMixBZ         !Žʬ(ܾ)
    39      use constants, only: PressBasis,        &!̤δవ         [Pa]
    40      &                    CpDry,             &!ʬʿ갵Ǯ [J/K kg]
    41      &                    MolWtDry,          &!ʬʿʬ   [kg/mol]
    42      &                    GasRDry             !ʬε     [J/K kg]
    43    use composition, only :   MolWtWet,          &!ʬʬ
    44      &                    SpcWetID,          &!ʬβؼID
    45      &                    CondNum,           &!ŷο
    46      &                    IdxCG,             &!ŷ()ź
    47      &                    IdxCC,             &!ŷ()ź
    48      &                    IdxNH3,            &!NH3()ź
    49      &                    IdxH2S,            &!H2S()ź
    50      &                    IdxNH4SHc           !NH4SH()ź
    51    use ChemCalc, only : xyz_SvapPress, xyz_LatentHeat, ReactHeatNH4SH, xyz_DQMixSatDPTemp, xyz_DelQMixNH4SH
    52  
    53    !ۤηػ
    54    implicit none
    55  
    56    !°λ
    57    private
    58  
    59    !ؿ° public ѹ
    60    public MoistAdjustSvapPress    !˰¾Ѥ˰¼Ĵ(ʰ)
    61    public MoistAdjustNH4SH        !ȿΰʿѤ˰¼Ĵ
    62  
    63  contains
    64  
    65  !!!------------------------------------------------------------------!!!
    66    subroutine MoistAdjustSvapPress(xyz_Exner, xyz_PTemp, xyzf_QMix)
    67      !
    68      ! ˰¾Ѥ˰Ĵˡμ¹
    69      ! ץǤ, ͽ᤿ȿɤԤ.
    70      !
    71  
    72      !ۤηػ
    73      implicit none
    74  
    75      !ѿ
    76      real(8),intent(in)   :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
    77                                                            !ʡؿ
    78      real(8),intent(inout):: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
    79                                                            !
    80      real(8),intent(inout):: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
    81                                                            !
    82      integer, parameter   :: ItrNum = 4                    !ȿɤβ
    83  
    84      real(DP):: xyz_QMixV_pre(imin:imax,jmin:jmax,kmin:kmax)
    85      real(DP):: xyz_QMixV_nxt(imin:imax,jmin:jmax,kmin:kmax)
    86      real(DP):: xyz_QMixC_pre(imin:imax,jmin:jmax,kmin:kmax)
    87      real(DP):: xyz_QMixC_nxt(imin:imax,jmin:jmax,kmin:kmax)
    88      real(DP):: xyz_PTemp_pre(imin:imax,jmin:jmax,kmin:kmax)
    89      real(DP):: xyz_PTemp_nxt(imin:imax,jmin:jmax,kmin:kmax)
    90      real(DP):: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax)
    91      real(DP):: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
    92      real(DP):: xyz_DelQMix(imin:imax,jmin:jmax,kmin:kmax)
    93      real(DP):: xyz_QMixSat(imin:imax,jmin:jmax,kmin:kmax)
    94      real(DP):: xyz_Cond(imin:imax,jmin:jmax,kmin:kmax)
    95      real(DP):: xyz_Evap(imin:imax,jmin:jmax,kmin:kmax)
    96      real(DP):: xyz_Gamma(imin:imax,jmin:jmax,kmin:kmax)
    97      integer :: i, s                                       ! ź
    98  
    99      !---------------------------------------------------------------------
   100      ! 
   101      !---------------------------------------------------------------------
   102      xyz_QMixV_pre  = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t625 = 1, xyz_qmixv_pre.DSC.U1 + 1 - xyz_qmixv_pre.DSC.L1      
     .           xyz_qmixv_pre(xyz_qmixv_pre.DSC.L1+t625-1,t623+                
     .       1      xyz_qmixv_pre.DSC.L2,t621+xyz_qmixv_pre.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t625-1,t623+                
     .       1      xyz_qmixv_nxt.DSC.L2,t621+xyz_qmixv_nxt.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixc_pre(xyz_qmixc_pre.DSC.L1+t625-1,t623+                
     .       1      xyz_qmixc_pre.DSC.L2,t621+xyz_qmixc_pre.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t625-1,t623+                
     .       1      xyz_qmixc_nxt.DSC.L2,t621+xyz_qmixc_nxt.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t625-1,t623+                
     .       1      xyz_ptemp_pre.DSC.L2,t621+xyz_ptemp_pre.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t625-1,t623+                
     .       1      xyz_ptemp_nxt.DSC.L2,t621+xyz_ptemp_nxt.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_exnerall(xyz_exnerall.DSC.L1+t625-1,t623+                  
     .       1      xyz_exnerall.DSC.L2,t621+xyz_exnerall.DSC.L3) =             
     .       2      0.0000000000000000e+000                                     
     .           xyz_tempall(xyz_tempall.DSC.L1+t625-1,t623+xyz_tempall.DSC.L2, 
     .       1      t621+xyz_tempall.DSC.L3) = 0.0000000000000000e+000          
     .           xyz_delqmix(xyz_delqmix.DSC.L1+t625-1,t623+xyz_delqmix.DSC.L2, 
     .       1      t621+xyz_delqmix.DSC.L3) = 0.0000000000000000e+000          
     .           xyz_qmixsat(xyz_qmixsat.DSC.L1+t625-1,t623+xyz_qmixsat.DSC.L2, 
     .       1      t621+xyz_qmixsat.DSC.L3) = 0.0000000000000000e+000          
     .           xyz_gamma(xyz_gamma.DSC.L1+t625-1,t623+xyz_gamma.DSC.L2,t621+  
     .       1      xyz_gamma.DSC.L3) = 0.0000000000000000e+000                 
     .        end do                                                            
   103      xyz_QMixV_nxt  = 0.0d0
   104      xyz_QMixC_pre  = 0.0d0
   105      xyz_QMixC_nxt  = 0.0d0
   106      xyz_PTemp_pre = 0.0d0
   107      xyz_PTemp_nxt = 0.0d0
   108  
   109      xyz_ExnerAll    = 0.0d0
   110      xyz_TempAll     = 0.0d0
   111      xyz_DelQMix    = 0.0d0
   112      xyz_QMixSat    = 0.0d0
   113      xyz_Gamma       = 0.0d0
   114  
   115      !---------------------------------------------------------------------
   116      ! ˰Ĵˡμ¹
   117      !   롼פ󤹤Τ, ˤĤƤ.
   118      !---------------------------------------------------------------------
   119      LoopSvapPress: do s = 1, CondNum
   120  
   121        !˰ˡǤϰϤѲʤ.
   122        xyz_ExnerAll = xyz_Exner + xyz_ExnerBZ
     .  !CDIR NODEP                                                             
     .        do t664 = 1, imax + 1 - imin                                      
     .           xyz_exnerall(xyz_exnerall.DSC.L1+t664-1,t662+                  
     .       1      xyz_exnerall.DSC.L2,t660+xyz_exnerall.DSC.L3) = xyz_exner(  
     .       2      t211+t664-1,t662+t213,t660+t215) + xyz_exnerbz(             
     .       3      xyz_exnerbz.DSC.L1+t664-1,t662+xyz_exnerbz.DSC.L2,t660+     
     .       4      xyz_exnerbz.DSC.L3)                                         
     .           xyz_qmixv_pre(xyz_qmixv_pre.DSC.L1+t664-1,t662+                
     .       1      xyz_qmixv_pre.DSC.L2,t660+xyz_qmixv_pre.DSC.L3) = xyzf_qmix(
     .       2      t231+t664-1,t662+t233,t660+t235,idxcg(s)) + xyzf_qmixbz(t12+
     .       3      t664-1,t662+t14,t660+t16,idxcg(s))                          
     .           xyz_qmixc_pre(xyz_qmixc_pre.DSC.L1+t664-1,t662+                
     .       1      xyz_qmixc_pre.DSC.L2,t660+xyz_qmixc_pre.DSC.L3) = xyzf_qmix(
     .       2      t231+t664-1,t662+t233,t660+t235,idxcc(s)) + xyzf_qmixbz(t12+
     .       3      t664-1,t662+t14,t660+t16,idxcc(s))                          
     .           xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t664-1,t662+                
     .       1      xyz_ptemp_pre.DSC.L2,t660+xyz_ptemp_pre.DSC.L3) = xyz_ptemp(
     .       2      t221+t664-1,t662+t223,t660+t225)                            
     .        end do                                                            
   123  
   124        !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
   125        xyz_QMixV_pre  = xyzf_QMix(:,:,:,IdxCG(s)) + xyzf_QMixBZ(:,:,:,IdxCG(s))
   126        xyz_QMixC_pre  = xyzf_QMix(:,:,:,IdxCC(s)) + xyzf_QMixBZ(:,:,:,IdxCC(s))
   127        xyz_PTemp_pre = xyz_PTemp
   128  
   129        Adjusting: do i = 1, ItrNum
   130          !---------------------------------------------------------------
   131          ! ˰¾˰º
   132          !---------------------------------------------------------------
   133          !
   134          xyz_TempAll = ( xyz_PTemp_pre + xyz_PTempBZ ) * xyz_ExnerAll
     .        if (xyz_ptemp_pre.DSC.U2 + 1 - xyz_ptemp_pre.DSC.L2 .gt. 0) then  
     .           J1 = and(xyz_ptemp_pre.DSC.U2 + 1 - xyz_ptemp_pre.DSC.L2,3)    
     .  !CDIR    NODEP                                                          
     .           do t701 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t703 = 1, xyz_ptemp_pre.DSC.U1 + 1 - xyz_ptemp_pre.DSC.L1
     .                 xyz_tempall(xyz_tempall.DSC.L1+t703-1,t701-1+            
     .       1            xyz_tempall.DSC.L2,t699+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t703-1,t701-1+     
     .       3            xyz_ptemp_pre.DSC.L2,t699+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t703-1,t701-1+         
     .       5            xyz_ptempbz.DSC.L2,t699+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t703-1,t701-1+       
     .       7            xyz_exnerall.DSC.L2,t699+xyz_exnerall.DSC.L3)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t701 = J1 + 1, xyz_ptemp_pre.DSC.U2 + 1 -                   
     .       1      xyz_ptemp_pre.DSC.L2, 4                                     
     .  !CDIR       NODEP                                                       
     .              do t703 = 1, xyz_ptemp_pre.DSC.U1 + 1 - xyz_ptemp_pre.DSC.L1
     .                 xyz_tempall(xyz_tempall.DSC.L1+t703-1,t701-1+            
     .       1            xyz_tempall.DSC.L2,t699+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t703-1,t701-1+     
     .       3            xyz_ptemp_pre.DSC.L2,t699+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t703-1,t701-1+         
     .       5            xyz_ptempbz.DSC.L2,t699+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t703-1,t701-1+       
     .       7            xyz_exnerall.DSC.L2,t699+xyz_exnerall.DSC.L3)         
     .                 xyz_tempall(xyz_tempall.DSC.L1+t703-1,t701+              
     .       1            xyz_tempall.DSC.L2,t699+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t703-1,t701+       
     .       3            xyz_ptemp_pre.DSC.L2,t699+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t703-1,t701+           
     .       5            xyz_ptempbz.DSC.L2,t699+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t703-1,t701+         
     .       7            xyz_exnerall.DSC.L2,t699+xyz_exnerall.DSC.L3)         
     .                 xyz_tempall(xyz_tempall.DSC.L1+t703-1,t701+1+            
     .       1            xyz_tempall.DSC.L2,t699+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t703-1,t701+1+     
     .       3            xyz_ptemp_pre.DSC.L2,t699+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t703-1,t701+1+         
     .       5            xyz_ptempbz.DSC.L2,t699+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t703-1,t701+1+       
     .       7            xyz_exnerall.DSC.L2,t699+xyz_exnerall.DSC.L3)         
     .                 xyz_tempall(xyz_tempall.DSC.L1+t703-1,t701+2+            
     .       1            xyz_tempall.DSC.L2,t699+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t703-1,t701+2+     
     .       3            xyz_ptemp_pre.DSC.L2,t699+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t703-1,t701+2+         
     .       5            xyz_ptempbz.DSC.L2,t699+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t703-1,t701+2+       
     .       7            xyz_exnerall.DSC.L2,t699+xyz_exnerall.DSC.L3)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   135  
   136          !˰¾˰º׻(ܾ줫κ).
   137          xyz_QMixSat =                                                    &
     .        if (%00060d.DSC.U2 - %00060d.DSC.L2 + 1 .gt. 0) then              
     .           J2 = and(%00060d.DSC.U2 - %00060d.DSC.L2 + 1,3)                
     .  !CDIR    NODEP                                                          
     .           do t719 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t721 = 1, %00060d.DSC.U1 + 1 - %00060d.DSC.L1            
     .                 xyz_qmixsat(xyz_qmixsat.DSC.L1+t721-1,t719-1+            
     .       1            xyz_qmixsat.DSC.L2,t717+xyz_qmixsat.DSC.L3) = %00060d(
     .       2            %00060d.DSC.L1+t721-1,t719-1+%00060d.DSC.L2,t717+     
     .       3            %00060d.DSC.L3)*molwtwet(idxcc(s))/(molwtdry*         
     .       4            pressbasis*xyz_exnerall(xyz_exnerall.DSC.L1+t721-1,   
     .       5            t719-1+xyz_exnerall.DSC.L2,t717+xyz_exnerall.DSC.L3)**
     .       6            (cpdry/gasrdry))                                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t719 = J2 + 1, %00060d.DSC.U2 - %00060d.DSC.L2 + 1, 4       
     .              D1 = molwtwet(idxcc(s))                                     
     .  !CDIR       NODEP                                                       
     .              do t721 = 1, %00060d.DSC.U1 + 1 - %00060d.DSC.L1            
     .                 xyz_qmixsat(xyz_qmixsat.DSC.L1+t721-1,t719-1+            
     .       1            xyz_qmixsat.DSC.L2,t717+xyz_qmixsat.DSC.L3) = %00060d(
     .       2            %00060d.DSC.L1+t721-1,t719-1+%00060d.DSC.L2,t717+     
     .       3            %00060d.DSC.L3)*D1/(molwtdry*pressbasis*xyz_exnerall( 
     .       4            xyz_exnerall.DSC.L1+t721-1,t719-1+xyz_exnerall.DSC.L2,
     .       5            t717+xyz_exnerall.DSC.L3)**(cpdry/gasrdry))           
     .                 xyz_qmixsat(xyz_qmixsat.DSC.L1+t721-1,t719+              
     .       1            xyz_qmixsat.DSC.L2,t717+xyz_qmixsat.DSC.L3) = %00060d(
     .       2            %00060d.DSC.L1+t721-1,t719+%00060d.DSC.L2,t717+       
     .       3            %00060d.DSC.L3)*D1/(molwtdry*pressbasis*xyz_exnerall( 
     .       4            xyz_exnerall.DSC.L1+t721-1,t719+xyz_exnerall.DSC.L2,  
     .       5            t717+xyz_exnerall.DSC.L3)**(cpdry/gasrdry))           
     .                 xyz_qmixsat(xyz_qmixsat.DSC.L1+t721-1,t719+1+            
     .       1            xyz_qmixsat.DSC.L2,t717+xyz_qmixsat.DSC.L3) = %00060d(
     .       2            %00060d.DSC.L1+t721-1,t719+1+%00060d.DSC.L2,t717+     
     .       3            %00060d.DSC.L3)*D1/(molwtdry*pressbasis*xyz_exnerall( 
     .       4            xyz_exnerall.DSC.L1+t721-1,t719+1+xyz_exnerall.DSC.L2,
     .       5            t717+xyz_exnerall.DSC.L3)**(cpdry/gasrdry))           
     .                 xyz_qmixsat(xyz_qmixsat.DSC.L1+t721-1,t719+2+            
     .       1            xyz_qmixsat.DSC.L2,t717+xyz_qmixsat.DSC.L3) = %00060d(
     .       2            %00060d.DSC.L1+t721-1,t719+2+%00060d.DSC.L2,t717+     
     .       3            %00060d.DSC.L3)*D1/(molwtdry*pressbasis*xyz_exnerall( 
     .       4            xyz_exnerall.DSC.L1+t721-1,t719+2+xyz_exnerall.DSC.L2,
     .       5            t717+xyz_exnerall.DSC.L3)**(cpdry/gasrdry))           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   138            & xyz_SvapPress(SpcWetID(IdxCC(s)), xyz_TempAll)               &
   139            &  * MolWtWet(IdxCC(s))                                        &
   140            &  / (MolWtDry * PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry)) )
   141  
   142          !ʲ줿Ǯ
   143          xyz_Gamma = xyz_LatentHeat(SpcWetID(IdxCC(s)), xyz_TempAll) &
     .        if (%000622.DSC.U2 - %000622.DSC.L2 + 1 .gt. 0) then              
     .           J3 = and(%000622.DSC.U2 - %000622.DSC.L2 + 1,3)                
     .  !CDIR    NODEP                                                          
     .           do t734 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t736 = 1, %000622.DSC.U1 + 1 - %000622.DSC.L1            
     .                 xyz_gamma(xyz_gamma.DSC.L1+t736-1,t734-1+xyz_gamma.DSC.L2
     .       1            ,t732+xyz_gamma.DSC.L3) = %000622(%000622.DSC.L1+t736-
     .       2            1,t734-1+%000622.DSC.L2,t732+%000622.DSC.L3)/(        
     .       3            xyz_exnerall(xyz_exnerall.DSC.L1+t736-1,t734-1+       
     .       4            xyz_exnerall.DSC.L2,t732+xyz_exnerall.DSC.L3)*cpdry)  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t734 = J3 + 1, %000622.DSC.U2 - %000622.DSC.L2 + 1, 4       
     .  !CDIR       NODEP                                                       
     .              do t736 = 1, %000622.DSC.U1 + 1 - %000622.DSC.L1            
     .                 xyz_gamma(xyz_gamma.DSC.L1+t736-1,t734-1+xyz_gamma.DSC.L2
     .       1            ,t732+xyz_gamma.DSC.L3) = %000622(%000622.DSC.L1+t736-
     .       2            1,t734-1+%000622.DSC.L2,t732+%000622.DSC.L3)/(        
     .       3            xyz_exnerall(xyz_exnerall.DSC.L1+t736-1,t734-1+       
     .       4            xyz_exnerall.DSC.L2,t732+xyz_exnerall.DSC.L3)*cpdry)  
     .                 xyz_gamma(xyz_gamma.DSC.L1+t736-1,t734+xyz_gamma.DSC.L2, 
     .       1            t732+xyz_gamma.DSC.L3) = %000622(%000622.DSC.L1+t736-1
     .       2            ,t734+%000622.DSC.L2,t732+%000622.DSC.L3)/(           
     .       3            xyz_exnerall(xyz_exnerall.DSC.L1+t736-1,t734+         
     .       4            xyz_exnerall.DSC.L2,t732+xyz_exnerall.DSC.L3)*cpdry)  
     .                 xyz_gamma(xyz_gamma.DSC.L1+t736-1,t734+1+xyz_gamma.DSC.L2
     .       1            ,t732+xyz_gamma.DSC.L3) = %000622(%000622.DSC.L1+t736-
     .       2            1,t734+1+%000622.DSC.L2,t732+%000622.DSC.L3)/(        
     .       3            xyz_exnerall(xyz_exnerall.DSC.L1+t736-1,t734+1+       
     .       4            xyz_exnerall.DSC.L2,t732+xyz_exnerall.DSC.L3)*cpdry)  
     .                 xyz_gamma(xyz_gamma.DSC.L1+t736-1,t734+2+xyz_gamma.DSC.L2
     .       1            ,t732+xyz_gamma.DSC.L3) = %000622(%000622.DSC.L1+t736-
     .       2            1,t734+2+%000622.DSC.L2,t732+%000622.DSC.L3)/(        
     .       3            xyz_exnerall(xyz_exnerall.DSC.L1+t736-1,t734+2+       
     .       4            xyz_exnerall.DSC.L2,t732+xyz_exnerall.DSC.L3)*cpdry)  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   144            &        / (xyz_ExnerAll * CpDry)
   145  
   146          !ŷ̤.
   147          !  ŷ뤬ˤ, xz_QMixV_pre - xz_QMixSat ɬͤȤʤ.
   148          !  ȯˤ, ȯ̤ - QMixC Ķ뤳ȤϤʤ.
   149          xyz_DelQMix = &
     .  !CDIR NODEP                                                             
     .        do t751 = 1, xyz_qmixv_pre.DSC.U1 + 1 - xyz_qmixv_pre.DSC.L1      
     .           xyz_delqmix(xyz_delqmix.DSC.L1+t751-1,t749+xyz_delqmix.DSC.L2, 
     .       1      t747+xyz_delqmix.DSC.L3) = (xyz_qmixv_pre(                  
     .       2      xyz_qmixv_pre.DSC.L1+t751-1,t749+xyz_qmixv_pre.DSC.L2,t747+ 
     .       3      xyz_qmixv_pre.DSC.L3)-xyz_qmixsat(xyz_qmixsat.DSC.L1+t751-1,
     .       4      t749+xyz_qmixsat.DSC.L2,t747+xyz_qmixsat.DSC.L3))/(         
     .       5      1.00000000000000e+000 + xyz_gamma(xyz_gamma.DSC.L1+t751-1,  
     .       6      t749+xyz_gamma.DSC.L2,t747+xyz_gamma.DSC.L3)*%000643(       
     .       7      %000643.DSC.L1+t751-1,t749+%000643.DSC.L2,t747+             
     .       8      %000643.DSC.L3))                                            
     .           xyz_cond(xyz_cond.DSC.L1+t751-1,t749+xyz_cond.DSC.L2,t747+     
     .       1      xyz_cond.DSC.L3) = max(0.0000000000000000e+000,min(         
     .       2      xyz_qmixv_pre(xyz_qmixv_pre.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixv_pre.DSC.L2,t747+xyz_qmixv_pre.DSC.L3),xyz_delqmix(
     .       4      xyz_delqmix.DSC.L1+t751-1,t749+xyz_delqmix.DSC.L2,t747+     
     .       5      xyz_delqmix.DSC.L3)))                                       
     .           xyz_evap(xyz_evap.DSC.L1+t751-1,t749+xyz_evap.DSC.L2,t747+     
     .       1      xyz_evap.DSC.L3) = max(0.0000000000000000e+000,min(         
     .       2      xyz_qmixc_pre(xyz_qmixc_pre.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixc_pre.DSC.L2,t747+xyz_qmixc_pre.DSC.L3),(-          
     .       4      xyz_delqmix(xyz_delqmix.DSC.L1+t751-1,t749+                 
     .       5      xyz_delqmix.DSC.L2,t747+xyz_delqmix.DSC.L3))))              
     .           xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t751-1,t749+                
     .       1      xyz_ptemp_nxt.DSC.L2,t747+xyz_ptemp_nxt.DSC.L3) =           
     .       2      xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t751-1,t749+             
     .       3      xyz_ptemp_pre.DSC.L2,t747+xyz_ptemp_pre.DSC.L3) + xyz_gamma(
     .       4      xyz_gamma.DSC.L1+t751-1,t749+xyz_gamma.DSC.L2,t747+         
     .       5      xyz_gamma.DSC.L3)*(xyz_cond(xyz_cond.DSC.L1+t751-1,t749+    
     .       6      xyz_cond.DSC.L2,t747+xyz_cond.DSC.L3)-xyz_evap(             
     .       7      xyz_evap.DSC.L1+t751-1,t749+xyz_evap.DSC.L2,t747+           
     .       8      xyz_evap.DSC.L3))                                           
     .           xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t751-1,t749+                
     .       1      xyz_qmixv_nxt.DSC.L2,t747+xyz_qmixv_nxt.DSC.L3) =           
     .       2      xyz_qmixv_pre(xyz_qmixv_pre.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixv_pre.DSC.L2,t747+xyz_qmixv_pre.DSC.L3) - xyz_cond( 
     .       4      xyz_cond.DSC.L1+t751-1,t749+xyz_cond.DSC.L2,t747+           
     .       5      xyz_cond.DSC.L3) + xyz_evap(xyz_evap.DSC.L1+t751-1,t749+    
     .       6      xyz_evap.DSC.L2,t747+xyz_evap.DSC.L3)                       
     .           xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t751-1,t749+                
     .       1      xyz_qmixc_nxt.DSC.L2,t747+xyz_qmixc_nxt.DSC.L3) =           
     .       2      xyz_qmixc_pre(xyz_qmixc_pre.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixc_pre.DSC.L2,t747+xyz_qmixc_pre.DSC.L3) + xyz_cond( 
     .       4      xyz_cond.DSC.L1+t751-1,t749+xyz_cond.DSC.L2,t747+           
     .       5      xyz_cond.DSC.L3) - xyz_evap(xyz_evap.DSC.L1+t751-1,t749+    
     .       6      xyz_evap.DSC.L2,t747+xyz_evap.DSC.L3)                       
     .           xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t751-1,t749+                
     .       1      xyz_ptemp_pre.DSC.L2,t747+xyz_ptemp_pre.DSC.L3) =           
     .       2      xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t751-1,t749+             
     .       3      xyz_ptemp_nxt.DSC.L2,t747+xyz_ptemp_nxt.DSC.L3)             
     .           xyz_qmixv_pre(xyz_qmixv_pre.DSC.L1+t751-1,t749+                
     .       1      xyz_qmixv_pre.DSC.L2,t747+xyz_qmixv_pre.DSC.L3) =           
     .       2      xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixv_nxt.DSC.L2,t747+xyz_qmixv_nxt.DSC.L3)             
     .           xyz_qmixc_pre(xyz_qmixc_pre.DSC.L1+t751-1,t749+                
     .       1      xyz_qmixc_pre.DSC.L2,t747+xyz_qmixc_pre.DSC.L3) =           
     .       2      xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t751-1,t749+             
     .       3      xyz_qmixc_nxt.DSC.L2,t747+xyz_qmixc_nxt.DSC.L3)             
     .        end do                                                            
   150            & ( xyz_QMixV_pre - xyz_QMixSat ) &
   151            &   / (1.0d0 + xyz_Gamma * xyz_DQMixSatDPTemp( &
   152            &        SpcWetID(IdxCC(s)), MolWtWet(IdxCC(s)), xyz_TempAll, xyz_ExnerAll &
   153            &        ) )
   154  
   155          xyz_Cond = max( 0.0d0, min( xyz_QMixV_pre,   xyz_DelQMix ) )
   156          xyz_Evap = max( 0.0d0, min( xyz_QMixC_pre, - xyz_DelQMix ) )
   157  
   158          !꿿˶ᤤͤ׻
   159          xyz_PTemp_nxt = xyz_PTemp_pre + xyz_Gamma * ( xyz_Cond - xyz_Evap )
   160          xyz_QMixV_nxt  = xyz_QMixV_pre  - xyz_Cond + xyz_Evap
   161          xyz_QMixC_nxt  = xyz_QMixC_pre  + xyz_Cond - xyz_Evap
   162  
   163          !֤Τѿ
   164          xyz_PTemp_pre = xyz_PTemp_nxt
   165          xyz_QMixV_pre  = xyz_QMixV_nxt
   166          xyz_QMixC_pre  = xyz_QMixC_nxt
   167  
   168        end do Adjusting
   169  
   170        xyz_PTemp                 = xyz_PTemp_nxt
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J4 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t845 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t847 = 1, imax + 1 - imin                                
     .                 xyz_ptemp(t221+t847-1,t845-1+t223,t843+t225) =           
     .       1            xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_ptemp_nxt.DSC.L2,t843+xyz_ptemp_nxt.DSC.L3)       
     .                 xyzf_qmix(t231+t847-1,t845-1+t233,t843+t235,idxcg(s)) =  
     .       1            xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_qmixv_nxt.DSC.L2,t843+xyz_qmixv_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845-1+t14,t843+t16,idxcg(s))  
     .                 xyzf_qmix(t231+t847-1,t845-1+t233,t843+t235,idxcc(s)) =  
     .       1            xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_qmixc_nxt.DSC.L2,t843+xyz_qmixc_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845-1+t14,t843+t16,idxcc(s))  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t845 = J4 + 1, jmax + 1 - jmin, 2                           
     .  !CDIR       NODEP                                                       
     .              do t847 = 1, imax + 1 - imin                                
     .                 xyz_ptemp(t221+t847-1,t845-1+t223,t843+t225) =           
     .       1            xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_ptemp_nxt.DSC.L2,t843+xyz_ptemp_nxt.DSC.L3)       
     .                 xyz_ptemp(t221+t847-1,t845+t223,t843+t225) =             
     .       1            xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t847-1,t845+       
     .       2            xyz_ptemp_nxt.DSC.L2,t843+xyz_ptemp_nxt.DSC.L3)       
     .                 xyzf_qmix(t231+t847-1,t845-1+t233,t843+t235,idxcg(s)) =  
     .       1            xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_qmixv_nxt.DSC.L2,t843+xyz_qmixv_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845-1+t14,t843+t16,idxcg(s))  
     .                 xyzf_qmix(t231+t847-1,t845+t233,t843+t235,idxcg(s)) =    
     .       1            xyz_qmixv_nxt(xyz_qmixv_nxt.DSC.L1+t847-1,t845+       
     .       2            xyz_qmixv_nxt.DSC.L2,t843+xyz_qmixv_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845+t14,t843+t16,idxcg(s))    
     .                 xyzf_qmix(t231+t847-1,t845-1+t233,t843+t235,idxcc(s)) =  
     .       1            xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t847-1,t845-1+     
     .       2            xyz_qmixc_nxt.DSC.L2,t843+xyz_qmixc_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845-1+t14,t843+t16,idxcc(s))  
     .                 xyzf_qmix(t231+t847-1,t845+t233,t843+t235,idxcc(s)) =    
     .       1            xyz_qmixc_nxt(xyz_qmixc_nxt.DSC.L1+t847-1,t845+       
     .       2            xyz_qmixc_nxt.DSC.L2,t843+xyz_qmixc_nxt.DSC.L3) -     
     .       3            xyzf_qmixbz(t12+t847-1,t845+t14,t843+t16,idxcc(s))    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   171        xyzf_QMix(:,:,:,IdxCG(s)) = xyz_QMixV_nxt - xyzf_QMixBZ(:,:,:,IdxCG(s))
   172        xyzf_QMix(:,:,:,IdxCC(s)) = xyz_QMixC_nxt - xyzf_QMixBZ(:,:,:,IdxCC(s))
   173  
   174      end do LoopSvapPress
   175  
   176    end subroutine MoistAdjustSvapPress
   177  
   178  
   179  !!!--------------------------------------------------------------------------!!!
   180    subroutine MoistAdjustNH4SH(xyz_Exner, xyz_PTemp, xyzf_QMix )
   181      !
   182      ! NH3 + H2S --> NH4SH ȿΰʿ Kp Ѥ˰¼Ĵˡ
   183      !
   184  
   185      !ۤηػ
   186      implicit none
   187  
   188      !ѿ
   189      real(8),intent(in)   :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax)
   190                                                            !ʡؿ
   191      real(8),intent(inout):: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax)
   192                                                            !
   193      real(8),intent(inout):: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   194                                                            !Žʬκ
   195      real(DP):: xyz_PTemp_pre(imin:imax,jmin:jmax,kmin:kmax)
   196      real(DP):: xyz_PTemp_nxt(imin:imax,jmin:jmax,kmin:kmax)
   197      real(DP):: xyz_QMixNH3_pre(imin:imax,jmin:jmax,kmin:kmax)
   198      real(DP):: xyz_QMixNH3_nxt(imin:imax,jmin:jmax,kmin:kmax)
   199      real(DP):: xyz_QMixH2S_pre(imin:imax,jmin:jmax,kmin:kmax)
   200      real(DP):: xyz_QMixH2S_nxt(imin:imax,jmin:jmax,kmin:kmax)
   201      real(DP):: xyz_QMixNH4SH_pre(imin:imax,jmin:jmax,kmin:kmax)
   202      real(DP):: xyz_QMixNH4SH_nxt(imin:imax,jmin:jmax,kmin:kmax)
   203  
   204      real(DP):: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax)
   205      real(DP):: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax)
   206      real(DP):: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax)
   207      real(DP):: xyz_Gamma(imin:imax,jmin:jmax,kmin:kmax)
   208      real(DP):: xyz_DelQMix(imin:imax,jmin:jmax,kmin:kmax)
   209      real(DP):: xyz_Cond(imin:imax,jmin:jmax,kmin:kmax)
   210      real(DP)::xyz_Evap(imin:imax,jmin:jmax,kmin:kmax)
   211  
   212      integer            :: i
   213      integer, parameter :: ItrNum = 2
   214  
   215      !---------------------------------------------------------------------
   216      ! 
   217      !---------------------------------------------------------------------
   218      xyz_PTemp_nxt = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t586 = 1, xyz_ptemp_nxt.DSC.U1 + 1 - xyz_ptemp_nxt.DSC.L1      
     .           xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t586-1,t584+                
     .       1      xyz_ptemp_nxt.DSC.L2,t582+xyz_ptemp_nxt.DSC.L3) =           
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixnh3_nxt(xyz_qmixnh3_nxt.DSC.L1+t586-1,t584+            
     .       1      xyz_qmixnh3_nxt.DSC.L2,t582+xyz_qmixnh3_nxt.DSC.L3) =       
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixh2s_nxt(xyz_qmixh2s_nxt.DSC.L1+t586-1,t584+            
     .       1      xyz_qmixh2s_nxt.DSC.L2,t582+xyz_qmixh2s_nxt.DSC.L3) =       
     .       2      0.0000000000000000e+000                                     
     .           xyz_qmixnh4sh_nxt(xyz_qmixnh4sh_nxt.DSC.L1+t586-1,t584+        
     .       1      xyz_qmixnh4sh_nxt.DSC.L2,t582+xyz_qmixnh4sh_nxt.DSC.L3) =   
     .       2      0.0000000000000000e+000                                     
     .           xyz_gamma(xyz_gamma.DSC.L1+t586-1,t584+xyz_gamma.DSC.L2,t582+  
     .       1      xyz_gamma.DSC.L3) = 0.0000000000000000e+000                 
     .           xyz_delqmix(xyz_delqmix.DSC.L1+t586-1,t584+xyz_delqmix.DSC.L2, 
     .       1      t582+xyz_delqmix.DSC.L3) = 0.0000000000000000e+000          
     .           xyz_exnerall(xyz_exnerall.DSC.L1+t586-1,t584+                  
     .       1      xyz_exnerall.DSC.L2,t582+xyz_exnerall.DSC.L3) = xyz_exner(  
     .       2      t192+t586-1,t584+t194,t582+t196) + xyz_exnerbz(             
     .       3      xyz_exnerbz.DSC.L1+t586-1,t584+xyz_exnerbz.DSC.L2,t582+     
     .       4      xyz_exnerbz.DSC.L3)                                         
     .           xyz_pressall(xyz_pressall.DSC.L1+t586-1,t584+                  
     .       1      xyz_pressall.DSC.L2,t582+xyz_pressall.DSC.L3) = pressbasis* 
     .       2      xyz_exnerall(xyz_exnerall.DSC.L1+t586-1,t584+               
     .       3      xyz_exnerall.DSC.L2,t582+xyz_exnerall.DSC.L3)**(cpdry/      
     .       4      gasrdry)                                                    
     .           xyz_qmixnh3_pre(xyz_qmixnh3_pre.DSC.L1+t586-1,t584+            
     .       1      xyz_qmixnh3_pre.DSC.L2,t582+xyz_qmixnh3_pre.DSC.L3) =       
     .       2      xyzf_qmix(t212+t586-1,t584+t214,t582+t216,idxnh3) +         
     .       3      xyzf_qmixbz(t12+t586-1,t584+t14,t582+t16,idxnh3)            
     .           xyz_qmixh2s_pre(xyz_qmixh2s_pre.DSC.L1+t586-1,t584+            
     .       1      xyz_qmixh2s_pre.DSC.L2,t582+xyz_qmixh2s_pre.DSC.L3) =       
     .       2      xyzf_qmix(t212+t586-1,t584+t214,t582+t216,idxh2s) +         
     .       3      xyzf_qmixbz(t12+t586-1,t584+t14,t582+t16,idxh2s)            
     .           xyz_qmixnh4sh_pre(xyz_qmixnh4sh_pre.DSC.L1+t586-1,t584+        
     .       1      xyz_qmixnh4sh_pre.DSC.L2,t582+xyz_qmixnh4sh_pre.DSC.L3) =   
     .       2      xyzf_qmix(t212+t586-1,t584+t214,t582+t216,idxnh4shc) +      
     .       3      xyzf_qmixbz(t12+t586-1,t584+t14,t582+t16,idxnh4shc)         
     .           xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t586-1,t584+                
     .       1      xyz_ptemp_pre.DSC.L2,t582+xyz_ptemp_pre.DSC.L3) = xyz_ptemp(
     .       2      t202+t586-1,t584+t204,t582+t206)                            
     .        end do                                                            
   219      xyz_QMixNH3_nxt   = 0.0d0
   220      xyz_QMixH2S_nxt   = 0.0d0
   221      xyz_QMixNH4SH_nxt = 0.0d0
   222  
   223      xyz_Gamma     = 0.0d0
   224      xyz_DelQMix  = 0.0d0
   225  
   226      !˰ˡǤϰϤѲʤ.
   227      xyz_ExnerAll = xyz_Exner + xyz_ExnerBZ
   228      xyz_PressAll = PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry))
   229  
   230      !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
   231      xyz_QMixNH3_pre(:,:,:)   = xyzf_QMix(:,:,:,IdxNH3) &
   232        &                           + xyzf_QMixBZ(:,:,:,IdxNH3)
   233      xyz_QMixH2S_pre(:,:,:)   = xyzf_QMix(:,:,:,IdxH2S) &
   234        &                           + xyzf_QMixBZ(:,:,:,IdxH2S)
   235      xyz_QMixNH4SH_pre(:,:,:) = xyzf_QMix(:,:,:,IdxNH4SHc) &
   236        &                           + xyzf_QMixBZ(:,:,:,IdxNH4SHc)
   237      xyz_PTemp_pre          = xyz_PTemp
   238  
   239      AdjustNH4SH: do i = 1, ItrNum
   240        !---------------------------------------------------------------
   241        ! ѿν
   242        !---------------------------------------------------------------
   243        !
   244        xyz_TempAll = ( xyz_PTemp_pre + xyz_PTempBZ ) * xyz_ExnerAll
     .        if (xyz_ptemp_pre.DSC.U2 + 1 - xyz_ptemp_pre.DSC.L2 .gt. 0) then  
     .           J1 = and(xyz_ptemp_pre.DSC.U2 + 1 - xyz_ptemp_pre.DSC.L2,1)    
     .  !CDIR    NODEP                                                          
     .           do t656 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t658 = 1, xyz_ptemp_pre.DSC.U1 + 1 - xyz_ptemp_pre.DSC.L1
     .                 xyz_tempall(xyz_tempall.DSC.L1+t658-1,t656-1+            
     .       1            xyz_tempall.DSC.L2,t654+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t658-1,t656-1+     
     .       3            xyz_ptemp_pre.DSC.L2,t654+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t658-1,t656-1+         
     .       5            xyz_ptempbz.DSC.L2,t654+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t658-1,t656-1+       
     .       7            xyz_exnerall.DSC.L2,t654+xyz_exnerall.DSC.L3)         
     .                 xyz_gamma(xyz_gamma.DSC.L1+t658-1,t656-1+xyz_gamma.DSC.L2
     .       1            ,t654+xyz_gamma.DSC.L3) = reactheatnh4sh/(xyz_exnerall
     .       2            (xyz_exnerall.DSC.L1+t658-1,t656-1+xyz_exnerall.DSC.L2
     .       3            ,t654+xyz_exnerall.DSC.L3)*cpdry)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t656 = J1 + 1, xyz_ptemp_pre.DSC.U2 + 1 -                   
     .       1      xyz_ptemp_pre.DSC.L2, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t658 = 1, xyz_ptemp_pre.DSC.U1 + 1 - xyz_ptemp_pre.DSC.L1
     .                 xyz_tempall(xyz_tempall.DSC.L1+t658-1,t656-1+            
     .       1            xyz_tempall.DSC.L2,t654+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t658-1,t656-1+     
     .       3            xyz_ptemp_pre.DSC.L2,t654+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t658-1,t656-1+         
     .       5            xyz_ptempbz.DSC.L2,t654+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t658-1,t656-1+       
     .       7            xyz_exnerall.DSC.L2,t654+xyz_exnerall.DSC.L3)         
     .                 xyz_tempall(xyz_tempall.DSC.L1+t658-1,t656+              
     .       1            xyz_tempall.DSC.L2,t654+xyz_tempall.DSC.L3) = (       
     .       2            xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t658-1,t656+       
     .       3            xyz_ptemp_pre.DSC.L2,t654+xyz_ptemp_pre.DSC.L3)+      
     .       4            xyz_ptempbz(xyz_ptempbz.DSC.L1+t658-1,t656+           
     .       5            xyz_ptempbz.DSC.L2,t654+xyz_ptempbz.DSC.L3))*         
     .       6            xyz_exnerall(xyz_exnerall.DSC.L1+t658-1,t656+         
     .       7            xyz_exnerall.DSC.L2,t654+xyz_exnerall.DSC.L3)         
     .                 xyz_gamma(xyz_gamma.DSC.L1+t658-1,t656-1+xyz_gamma.DSC.L2
     .       1            ,t654+xyz_gamma.DSC.L3) = reactheatnh4sh/(xyz_exnerall
     .       2            (xyz_exnerall.DSC.L1+t658-1,t656-1+xyz_exnerall.DSC.L2
     .       3            ,t654+xyz_exnerall.DSC.L3)*cpdry)                     
     .                 xyz_gamma(xyz_gamma.DSC.L1+t658-1,t656+xyz_gamma.DSC.L2, 
     .       1            t654+xyz_gamma.DSC.L3) = reactheatnh4sh/(xyz_exnerall(
     .       2            xyz_exnerall.DSC.L1+t658-1,t656+xyz_exnerall.DSC.L2,  
     .       3            t654+xyz_exnerall.DSC.L3)*cpdry)                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   245  
   246        !ʲ줿ȿǮ (NH4SH kg ФǮ)
   247        xyz_Gamma = ReactHeatNH4SH / ( xyz_ExnerAll * CpDry )
   248  
   249        !NH4SH 
   250        xyz_DelQMix =                                                           &
   251          &    xyz_DelQMixNH4SH(                                                &
   252          &          xyz_TempAll, xyz_PressAll, xyz_QMixNH3_pre, xyz_QMixH2S_pre, &
   253          &          MolWtWet(IdxNH3), MolWtWet(IdxH2S)                         &
   254          &      )
   255  
   256        xyz_Cond = max( 0.0d0, xyz_DelQMix )
     .        D1 = molwtwet(idxnh3)/molwtwet(idxnh4shc)                         
     .        D2 = molwtwet(idxh2s)/molwtwet(idxnh4shc)                         
     .  !CDIR NODEP                                                             
     .        do t682 = 1, t71 + 1 - t72                                        
     .           xyz_cond(xyz_cond.DSC.L1+t682-1,t680+xyz_cond.DSC.L2,t678+     
     .       1      xyz_cond.DSC.L3) = max(0.0000000000000000e+000,xyz_delqmix( 
     .       2      t72+t682-1,t680+t74,t678+t76))                              
     .           xyz_evap(xyz_evap.DSC.L1+t682-1,t680+xyz_evap.DSC.L2,t678+     
     .       1      xyz_evap.DSC.L3) = max(0.0000000000000000e+000,min((-       
     .       2      xyz_delqmix(t72+t682-1,t680+t74,t678+t76)),xyz_qmixnh4sh_pre
     .       3      (xyz_qmixnh4sh_pre.DSC.L1+t682-1,t680+                      
     .       4      xyz_qmixnh4sh_pre.DSC.L2,t678+xyz_qmixnh4sh_pre.DSC.L3)))   
     .           xyz_qmixnh4sh_nxt(xyz_qmixnh4sh_nxt.DSC.L1+t682-1,t680+        
     .       1      xyz_qmixnh4sh_nxt.DSC.L2,t678+xyz_qmixnh4sh_nxt.DSC.L3) =   
     .       2      xyz_qmixnh4sh_pre(xyz_qmixnh4sh_pre.DSC.L1+t682-1,t680+     
     .       3      xyz_qmixnh4sh_pre.DSC.L2,t678+xyz_qmixnh4sh_pre.DSC.L3) +   
     .       4      xyz_cond(xyz_cond.DSC.L1+t682-1,t680+xyz_cond.DSC.L2,t678+  
     .       5      xyz_cond.DSC.L3) - xyz_evap(xyz_evap.DSC.L1+t682-1,t680+    
     .       6      xyz_evap.DSC.L2,t678+xyz_evap.DSC.L3)                       
     .           xyz_qmixnh3_nxt(xyz_qmixnh3_nxt.DSC.L1+t682-1,t680+            
     .       1      xyz_qmixnh3_nxt.DSC.L2,t678+xyz_qmixnh3_nxt.DSC.L3) =       
     .       2      xyz_qmixnh3_pre(xyz_qmixnh3_pre.DSC.L1+t682-1,t680+         
     .       3      xyz_qmixnh3_pre.DSC.L2,t678+xyz_qmixnh3_pre.DSC.L3) - (     
     .       4      xyz_cond(xyz_cond.DSC.L1+t682-1,t680+xyz_cond.DSC.L2,t678+  
     .       5      xyz_cond.DSC.L3)-xyz_evap(xyz_evap.DSC.L1+t682-1,t680+      
     .       6      xyz_evap.DSC.L2,t678+xyz_evap.DSC.L3))*D1                   
     .           xyz_qmixh2s_nxt(xyz_qmixh2s_nxt.DSC.L1+t682-1,t680+            
     .       1      xyz_qmixh2s_nxt.DSC.L2,t678+xyz_qmixh2s_nxt.DSC.L3) =       
     .       2      xyz_qmixh2s_pre(xyz_qmixh2s_pre.DSC.L1+t682-1,t680+         
     .       3      xyz_qmixh2s_pre.DSC.L2,t678+xyz_qmixh2s_pre.DSC.L3) - (     
     .       4      xyz_cond(xyz_cond.DSC.L1+t682-1,t680+xyz_cond.DSC.L2,t678+  
     .       5      xyz_cond.DSC.L3)-xyz_evap(xyz_evap.DSC.L1+t682-1,t680+      
     .       6      xyz_evap.DSC.L2,t678+xyz_evap.DSC.L3))*D2                   
     .           xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t682-1,t680+                
     .       1      xyz_ptemp_nxt.DSC.L2,t678+xyz_ptemp_nxt.DSC.L3) =           
     .       2      xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t682-1,t680+             
     .       3      xyz_ptemp_pre.DSC.L2,t678+xyz_ptemp_pre.DSC.L3) + xyz_gamma(
     .       4      xyz_gamma.DSC.L1+t682-1,t680+xyz_gamma.DSC.L2,t678+         
     .       5      xyz_gamma.DSC.L3)*(xyz_cond(xyz_cond.DSC.L1+t682-1,t680+    
     .       6      xyz_cond.DSC.L2,t678+xyz_cond.DSC.L3)-xyz_evap(             
     .       7      xyz_evap.DSC.L1+t682-1,t680+xyz_evap.DSC.L2,t678+           
     .       8      xyz_evap.DSC.L3))                                           
     .           xyz_ptemp_pre(xyz_ptemp_pre.DSC.L1+t682-1,t680+                
     .       1      xyz_ptemp_pre.DSC.L2,t678+xyz_ptemp_pre.DSC.L3) =           
     .       2      xyz_ptemp_nxt(xyz_ptemp_nxt.DSC.L1+t682-1,t680+             
     .       3      xyz_ptemp_nxt.DSC.L2,t678+xyz_ptemp_nxt.DSC.L3)             
     .           xyz_qmixnh3_pre(xyz_qmixnh3_pre.DSC.L1+t682-1,t680+            
     .       1      xyz_qmixnh3_pre.DSC.L2,t678+xyz_qmixnh3_pre.DSC.L3) =       
     .       2      xyz_qmixnh3_nxt(xyz_qmixnh3_nxt.DSC.L1+t682-1,t680+         
     .       3      xyz_qmixnh3_nxt.DSC.L2,t678+xyz_qmixnh3_nxt.DSC.L3)         
     .           xyz_qmixh2s_pre(xyz_qmixh2s_pre.DSC.L1+t682-1,t680+            
     .       1      xyz_qmixh2s_pre.DSC.L2,t678+xyz_qmixh2s_pre.DSC.L3) =       
     .       2      xyz_qmixh2s_nxt(xyz_qmixh2s_nxt.DSC.L1+t682-1,t680+         
     .       3      xyz_qmixh2s_nxt.DSC.L2,t678+xyz_qmixh2s_nxt.DSC.L3)         
     .           xyz_qmixnh4sh_pre(xyz_qmixnh4sh_pre.DSC.L1+t682-1,t680+        
     .       1      xyz_qmixnh4sh_pre.DSC.L2,t678+xyz_qmixnh4sh_pre.DSC.L3) =   
     .       2      xyz_qmixnh4sh_nxt(xyz_qmixnh4sh_nxt.DSC.L1+t682-1,t680+     
     .       3      xyz_qmixnh4sh_nxt.DSC.L2,t678+xyz_qmixnh4sh_nxt.DSC.L3)     
     .        end do                                                            
   257        xyz_Evap = max( 0.0d0, min( - xyz_DelQMix, xyz_QMixNH4SH_pre ) )
   258  
   259        !---------------------------------------------------------------
   260        ! 꿿˶ᤤͤ˰¾˰º
   261        !---------------------------------------------------------------
   262        ! NH4SH κ
   263        xyz_QMixNH4SH_nxt  = xyz_QMixNH4SH_pre + xyz_Cond - xyz_Evap
   264  
   265        ! DelPress 򸵤, NH3  H2S κ
   266        xyz_QMixNH3_nxt = xyz_QMixNH3_pre - ( xyz_Cond - xyz_Evap )      &
   267          &                 * MolWtWet(IdxNH3) / MolWtWet(IdxNH4SHc)
   268        xyz_QMixH2S_nxt = xyz_QMixH2S_pre - ( xyz_Cond - xyz_Evap )      &
   269          &                 * MolWtWet(IdxH2S) / MolWtWet(IdxNH4SHc)
   270  
   271        !̤
   272        xyz_PTemp_nxt = xyz_PTemp_pre + xyz_Gamma * ( xyz_Cond - xyz_Evap )
   273  
   274        !롼פ󤹤ѿѲ
   275        xyz_PTemp_pre    = xyz_PTemp_nxt
   276        xyz_QMixNH3_pre   = xyz_QMixNH3_nxt
   277        xyz_QMixH2S_pre   = xyz_QMixH2S_nxt
   278        xyz_QMixNH4SH_pre = xyz_QMixNH4SH_nxt
   279  
   280      end do AdjustNH4SH
   281  
   282      xyz_PTemp                  = xyz_PTemp_nxt
     .  !CDIR NODEP                                                             
     .        do t778 = 1, imax + 1 - imin                                      
     .           xyz_ptemp(t202+t778-1,t776+t204,t774+t206) = xyz_ptemp_nxt(    
     .       1      xyz_ptemp_nxt.DSC.L1+t778-1,t776+xyz_ptemp_nxt.DSC.L2,t774+ 
     .       2      xyz_ptemp_nxt.DSC.L3)                                       
     .           xyzf_qmix(t212+t778-1,t776+t214,t774+t216,idxnh3) =            
     .       1      xyz_qmixnh3_nxt(xyz_qmixnh3_nxt.DSC.L1+t778-1,t776+         
     .       2      xyz_qmixnh3_nxt.DSC.L2,t774+xyz_qmixnh3_nxt.DSC.L3) -       
     .       3      xyzf_qmixbz(t12+t778-1,t776+t14,t774+t16,idxnh3)            
     .           xyzf_qmix(t212+t778-1,t776+t214,t774+t216,idxh2s) =            
     .       1      xyz_qmixh2s_nxt(xyz_qmixh2s_nxt.DSC.L1+t778-1,t776+         
     .       2      xyz_qmixh2s_nxt.DSC.L2,t774+xyz_qmixh2s_nxt.DSC.L3) -       
     .       3      xyzf_qmixbz(t12+t778-1,t776+t14,t774+t16,idxh2s)            
     .           xyzf_qmix(t212+t778-1,t776+t214,t774+t216,idxnh4shc) =         
     .       1      xyz_qmixnh4sh_nxt(xyz_qmixnh4sh_nxt.DSC.L1+t778-1,t776+     
     .       2      xyz_qmixnh4sh_nxt.DSC.L2,t774+xyz_qmixnh4sh_nxt.DSC.L3) -   
     .       3      xyzf_qmixbz(t12+t778-1,t776+t14,t774+t16,idxnh4shc)         
     .        end do                                                            
   283      xyzf_QMix(:,:,:,IdxNH3)    = xyz_QMixNH3_nxt   - xyzf_QMixBZ(:,:,:,IdxNH3)
   284      xyzf_QMix(:,:,:,IdxH2S)    = xyz_QMixH2S_nxt   - xyzf_QMixBZ(:,:,:,IdxH2S)
   285      xyzf_QMix(:,:,:,IdxNH4SHc) = xyz_QMixNH4SH_nxt - xyzf_QMixBZ(:,:,:,IdxNH4SHc)
   286  
   287    end subroutine MoistAdjustNH4SH
   288  
   289  
   290  end Module MoistAdjust
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:35:10 2011
FILE NAME: moistadjust.f90
PROGRAM NAME: moistadjust
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module MoistAdjust
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
     4:            ! Version::   $Id: moistadjust.f90,v 1.4 2011-06-03 06:11:22 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview
    10:            !
    11:            !˰Ĵˡ
    12:            ! 
    13:            !== Error Handling
    14:            !
    15:            !== Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !== Future Plans
    20:            !
    21:            !
    22:            
    23:            Module MoistAdjust
    24:              !
    25:              !˰ĴˡԤΥѥå⥸塼
    26:              !  * ˰¾Ȥؼ, 층Ū˼¹Ԥ
    27:              !  * ȿˤĤƤ, 줾βȿ˼¹Ԥ. 
    28:            
    29:              !⥸塼ɤ߹
    30:              use dc_types,   only : DP
    31:              use dc_message, only : MessageNotify
    32:              use gridset, only :    ncmax,                &!ؼο
    33:                &                    imin, imax,        &!x ξ¤Ȳ
    34:                &                    jmin, jmax,        &!y ξ
    35:                &                    kmin, kmax          !z β
    36:              use basicset,only :    xyz_ExnerBZ,       &!̵(ܾ)
    37:                &                    xyz_PTempBZ,       &!(ܾ)
    38:                &                    xyzf_QMixBZ         !Žʬ(ܾ)
    39:                use constants, only: PressBasis,        &!̤δవ         [Pa]
    40:                &                    CpDry,             &!ʬʿ갵Ǯ [J/K kg]
    41:                &                    MolWtDry,          &!ʬʿʬ   [kg/mol]
    42:                &                    GasRDry             !ʬε     [J/K kg]
    43:              use composition, only :   MolWtWet,          &!ʬʬ  
    44:                &                    SpcWetID,          &!ʬβؼID 
    45:                &                    CondNum,           &!ŷο
    46:                &                    IdxCG,             &!ŷ()ź
    47:                &                    IdxCC,             &!ŷ()ź
    48:                &                    IdxNH3,            &!NH3()ź
    49:                &                    IdxH2S,            &!H2S()ź
    50:                &                    IdxNH4SHc           !NH4SH()ź
    51:              use ChemCalc, only : xyz_SvapPress, xyz_LatentHeat, ReactHeatNH4SH, xyz_DQMixSatDPTemp, xyz_DelQMixNH4SH
    52:            
    53:              !ۤηػ
    54:              implicit none
    55:              
    56:              !°λ
    57:              private
    58:            
    59:              !ؿ° public ѹ
    60:              public MoistAdjustSvapPress    !˰¾Ѥ˰¼Ĵ(ʰ)
    61:              public MoistAdjustNH4SH        !ȿΰʿѤ˰¼Ĵ
    62:            
    63:            contains
    64:            
    65:            !!!------------------------------------------------------------------!!!
    66:              subroutine MoistAdjustSvapPress(xyz_Exner, xyz_PTemp, xyzf_QMix)
    67:                !
    68:                ! ˰¾Ѥ˰Ĵˡμ¹
    69:                ! ץǤ, ͽ᤿ȿɤԤ. 
    70:                !
    71:            
    72:                !ۤηػ
    73:                implicit none
    74:                
    75:                !ѿ
    76:                real(8),intent(in)   :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax) 
    77:                                                                      !ʡؿ
    78:                real(8),intent(inout):: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax) 
    79:                                                                      !
    80:                real(8),intent(inout):: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
    81:                                                                      !
    82:                integer, parameter   :: ItrNum = 4                    !ȿɤβ
    83:            
    84:                real(DP):: xyz_QMixV_pre(imin:imax,jmin:jmax,kmin:kmax) 
    85:                real(DP):: xyz_QMixV_nxt(imin:imax,jmin:jmax,kmin:kmax) 
    86:                real(DP):: xyz_QMixC_pre(imin:imax,jmin:jmax,kmin:kmax) 
    87:                real(DP):: xyz_QMixC_nxt(imin:imax,jmin:jmax,kmin:kmax) 
    88:                real(DP):: xyz_PTemp_pre(imin:imax,jmin:jmax,kmin:kmax) 
    89:                real(DP):: xyz_PTemp_nxt(imin:imax,jmin:jmax,kmin:kmax) 
    90:                real(DP):: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax) 
    91:                real(DP):: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax) 
    92:                real(DP):: xyz_DelQMix(imin:imax,jmin:jmax,kmin:kmax) 
    93:                real(DP):: xyz_QMixSat(imin:imax,jmin:jmax,kmin:kmax) 
    94:                real(DP):: xyz_Cond(imin:imax,jmin:jmax,kmin:kmax)  
    95:                real(DP):: xyz_Evap(imin:imax,jmin:jmax,kmin:kmax)  
    96:                real(DP):: xyz_Gamma(imin:imax,jmin:jmax,kmin:kmax) 
    97:                integer :: i, s                                       ! ź  
    98:            
    99:                !---------------------------------------------------------------------
   100:                ! 
   101:                !---------------------------------------------------------------------
   102: **V---->       xyz_QMixV_pre  = 0.0d0
   103: |||            xyz_QMixV_nxt  = 0.0d0
   104: |||            xyz_QMixC_pre  = 0.0d0
   105: |||            xyz_QMixC_nxt  = 0.0d0
   106: |||            xyz_PTemp_pre = 0.0d0
   107: |||            xyz_PTemp_nxt = 0.0d0
   108: |||            
   109: |||            xyz_ExnerAll    = 0.0d0
   110: |||            xyz_TempAll     = 0.0d0
   111: |||            xyz_DelQMix    = 0.0d0
   112: |||            xyz_QMixSat    = 0.0d0 
   113: **V----        xyz_Gamma       = 0.0d0
   114:                
   115:                !---------------------------------------------------------------------
   116:                ! ˰Ĵˡμ¹
   117:                !   롼פ󤹤Τ, ˤĤƤ.  
   118:                !---------------------------------------------------------------------
   119: +------>       LoopSvapPress: do s = 1, CondNum
   120: |                
   121: |                !˰ˡǤϰϤѲʤ. 
   122: |**V--->         xyz_ExnerAll = xyz_Exner + xyz_ExnerBZ
   123: ||||                 
   124: ||||             !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
   125: ||||             xyz_QMixV_pre  = xyzf_QMix(:,:,:,IdxCG(s)) + xyzf_QMixBZ(:,:,:,IdxCG(s))
   126: ||||             xyz_QMixC_pre  = xyzf_QMix(:,:,:,IdxCC(s)) + xyzf_QMixBZ(:,:,:,IdxCC(s))
   127: |**V---          xyz_PTemp_pre = xyz_PTemp
   128: |          
   129: |+----->         Adjusting: do i = 1, ItrNum
   130: ||                 !---------------------------------------------------------------
   131: ||                 ! ˰¾˰º
   132: ||                 !---------------------------------------------------------------
   133: ||                 !
   134: ||++V==            xyz_TempAll = ( xyz_PTemp_pre + xyz_PTempBZ ) * xyz_ExnerAll
   135: ||         
   136: ||                 !˰¾˰º׻(ܾ줫κ). 
   137: ||++V==            xyz_QMixSat =                                                    &
   138: ||                   & xyz_SvapPress(SpcWetID(IdxCC(s)), xyz_TempAll)               &
   139: ||                   &  * MolWtWet(IdxCC(s))                                        &
   140: ||                   &  / (MolWtDry * PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry)) )
   141: ||         
   142: ||                 !ʲ줿Ǯ
   143: ||++V==            xyz_Gamma = xyz_LatentHeat(SpcWetID(IdxCC(s)), xyz_TempAll) &
   144: ||                   &        / (xyz_ExnerAll * CpDry)
   145: ||         
   146: ||                 !ŷ̤. 
   147: ||                 !  ŷ뤬ˤ, xz_QMixV_pre - xz_QMixSat ɬͤȤʤ.
   148: ||                 !  ȯˤ, ȯ̤ - QMixC Ķ뤳ȤϤʤ. 
   149: ||**V-->           xyz_DelQMix = &
   150: |||||                & ( xyz_QMixV_pre - xyz_QMixSat ) &
   151: |||||                &   / (1.0d0 + xyz_Gamma * xyz_DQMixSatDPTemp( &
   152: |||||                &        SpcWetID(IdxCC(s)), MolWtWet(IdxCC(s)), xyz_TempAll, xyz_ExnerAll & 
   153: |||||                &        ) )
   154: |||||      
   155: |||||              xyz_Cond = max( 0.0d0, min( xyz_QMixV_pre,   xyz_DelQMix ) )
   156: |||||              xyz_Evap = max( 0.0d0, min( xyz_QMixC_pre, - xyz_DelQMix ) )
   157: |||||      
   158: |||||              !꿿˶ᤤͤ׻
   159: |||||              xyz_PTemp_nxt = xyz_PTemp_pre + xyz_Gamma * ( xyz_Cond - xyz_Evap )
   160: |||||              xyz_QMixV_nxt  = xyz_QMixV_pre  - xyz_Cond + xyz_Evap
   161: |||||              xyz_QMixC_nxt  = xyz_QMixC_pre  + xyz_Cond - xyz_Evap
   162: |||||      
   163: |||||              !֤Τѿ
   164: |||||              xyz_PTemp_pre = xyz_PTemp_nxt
   165: |||||              xyz_QMixV_pre  = xyz_QMixV_nxt
   166: ||**V--            xyz_QMixC_pre  = xyz_QMixC_nxt
   167: ||         
   168: |+-----          end do Adjusting
   169: |                
   170: |**V--->         xyz_PTemp                 = xyz_PTemp_nxt                 
   171: ||||             xyzf_QMix(:,:,:,IdxCG(s)) = xyz_QMixV_nxt - xyzf_QMixBZ(:,:,:,IdxCG(s))
   172: |**V---          xyzf_QMix(:,:,:,IdxCC(s)) = xyz_QMixC_nxt - xyzf_QMixBZ(:,:,:,IdxCC(s))
   173: |                
   174: +------        end do LoopSvapPress
   175:                
   176:              end subroutine MoistAdjustSvapPress
   177:            
   178:            
   179:            !!!--------------------------------------------------------------------------!!!
   180:              subroutine MoistAdjustNH4SH(xyz_Exner, xyz_PTemp, xyzf_QMix ) 
   181:                !
   182:                ! NH3 + H2S --> NH4SH ȿΰʿ Kp Ѥ˰¼Ĵˡ
   183:                !
   184:                
   185:                !ۤηػ
   186:                implicit none
   187:                
   188:                !ѿ
   189:                real(8),intent(in)   :: xyz_Exner(imin:imax,jmin:jmax,kmin:kmax) 
   190:                                                                      !ʡؿ
   191:                real(8),intent(inout):: xyz_PTemp(imin:imax,jmin:jmax,kmin:kmax) 
   192:                                                                      !
   193:                real(8),intent(inout):: xyzf_QMix(imin:imax,jmin:jmax,kmin:kmax, ncmax)
   194:                                                                      !Žʬκ
   195:                real(DP):: xyz_PTemp_pre(imin:imax,jmin:jmax,kmin:kmax) 
   196:                real(DP):: xyz_PTemp_nxt(imin:imax,jmin:jmax,kmin:kmax) 
   197:                real(DP):: xyz_QMixNH3_pre(imin:imax,jmin:jmax,kmin:kmax) 
   198:                real(DP):: xyz_QMixNH3_nxt(imin:imax,jmin:jmax,kmin:kmax) 
   199:                real(DP):: xyz_QMixH2S_pre(imin:imax,jmin:jmax,kmin:kmax) 
   200:                real(DP):: xyz_QMixH2S_nxt(imin:imax,jmin:jmax,kmin:kmax) 
   201:                real(DP):: xyz_QMixNH4SH_pre(imin:imax,jmin:jmax,kmin:kmax) 
   202:                real(DP):: xyz_QMixNH4SH_nxt(imin:imax,jmin:jmax,kmin:kmax) 
   203:                
   204:                real(DP):: xyz_ExnerAll(imin:imax,jmin:jmax,kmin:kmax) 
   205:                real(DP):: xyz_PressAll(imin:imax,jmin:jmax,kmin:kmax) 
   206:                real(DP):: xyz_TempAll(imin:imax,jmin:jmax,kmin:kmax) 
   207:                real(DP):: xyz_Gamma(imin:imax,jmin:jmax,kmin:kmax) 
   208:                real(DP):: xyz_DelQMix(imin:imax,jmin:jmax,kmin:kmax) 
   209:                real(DP):: xyz_Cond(imin:imax,jmin:jmax,kmin:kmax)  
   210:                real(DP)::xyz_Evap(imin:imax,jmin:jmax,kmin:kmax)  
   211:                
   212:                integer            :: i
   213:                integer, parameter :: ItrNum = 2
   214:                        
   215:                !---------------------------------------------------------------------
   216:                ! 
   217:                !---------------------------------------------------------------------
   218: **V---->       xyz_PTemp_nxt = 0.0d0
   219: |||            xyz_QMixNH3_nxt   = 0.0d0
   220: |||            xyz_QMixH2S_nxt   = 0.0d0
   221: |||            xyz_QMixNH4SH_nxt = 0.0d0
   222: |||            
   223: |||            xyz_Gamma     = 0.0d0
   224: |||            xyz_DelQMix  = 0.0d0
   225: |||        
   226: |||            !˰ˡǤϰϤѲʤ. 
   227: |||            xyz_ExnerAll = xyz_Exner + xyz_ExnerBZ
   228: |||            xyz_PressAll = PressBasis * (xyz_ExnerAll ** (CpDry / GasRDry))
   229: |||                
   230: |||            !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
   231: |||            xyz_QMixNH3_pre(:,:,:)   = xyzf_QMix(:,:,:,IdxNH3) &
   232: |||              &                           + xyzf_QMixBZ(:,:,:,IdxNH3)
   233: |||            xyz_QMixH2S_pre(:,:,:)   = xyzf_QMix(:,:,:,IdxH2S) &
   234: |||              &                           + xyzf_QMixBZ(:,:,:,IdxH2S)
   235: |||            xyz_QMixNH4SH_pre(:,:,:) = xyzf_QMix(:,:,:,IdxNH4SHc) &
   236: |||              &                           + xyzf_QMixBZ(:,:,:,IdxNH4SHc)
   237: **V----        xyz_PTemp_pre          = xyz_PTemp
   238:            
   239: +------>       AdjustNH4SH: do i = 1, ItrNum
   240: |                !---------------------------------------------------------------
   241: |                ! ѿν
   242: |                !---------------------------------------------------------------
   243: |                !
   244: |**V--->         xyz_TempAll = ( xyz_PTemp_pre + xyz_PTempBZ ) * xyz_ExnerAll
   245: ||||             
   246: ||||             !ʲ줿ȿǮ (NH4SH kg ФǮ)
   247: |**V---          xyz_Gamma = ReactHeatNH4SH / ( xyz_ExnerAll * CpDry )
   248: |          
   249: |                !NH4SH 
   250: |                xyz_DelQMix =                                                           &
   251: |                  &    xyz_DelQMixNH4SH(                                                &
   252: |                  &          xyz_TempAll, xyz_PressAll, xyz_QMixNH3_pre, xyz_QMixH2S_pre, &
   253: |                  &          MolWtWet(IdxNH3), MolWtWet(IdxH2S)                         &
   254: |                  &      )
   255: |          
   256: |**V--->         xyz_Cond = max( 0.0d0, xyz_DelQMix )
   257: ||||             xyz_Evap = max( 0.0d0, min( - xyz_DelQMix, xyz_QMixNH4SH_pre ) )
   258: ||||       
   259: ||||             !---------------------------------------------------------------
   260: ||||             ! 꿿˶ᤤͤ˰¾˰º
   261: ||||             !---------------------------------------------------------------
   262: ||||             ! NH4SH κ
   263: ||||             xyz_QMixNH4SH_nxt  = xyz_QMixNH4SH_pre + xyz_Cond - xyz_Evap
   264: ||||             
   265: ||||             ! DelPress 򸵤, NH3  H2S κ
   266: ||||             xyz_QMixNH3_nxt = xyz_QMixNH3_pre - ( xyz_Cond - xyz_Evap )      &
   267: ||||               &                 * MolWtWet(IdxNH3) / MolWtWet(IdxNH4SHc)
   268: ||||             xyz_QMixH2S_nxt = xyz_QMixH2S_pre - ( xyz_Cond - xyz_Evap )      &
   269: ||||               &                 * MolWtWet(IdxH2S) / MolWtWet(IdxNH4SHc)
   270: ||||                 
   271: ||||             !̤
   272: ||||             xyz_PTemp_nxt = xyz_PTemp_pre + xyz_Gamma * ( xyz_Cond - xyz_Evap )
   273: ||||             
   274: ||||             !롼פ󤹤ѿѲ
   275: ||||             xyz_PTemp_pre    = xyz_PTemp_nxt
   276: ||||             xyz_QMixNH3_pre   = xyz_QMixNH3_nxt 
   277: ||||             xyz_QMixH2S_pre   = xyz_QMixH2S_nxt 
   278: |**V---          xyz_QMixNH4SH_pre = xyz_QMixNH4SH_nxt 
   279: |          
   280: +------        end do AdjustNH4SH
   281:            
   282: **V---->       xyz_PTemp                  = xyz_PTemp_nxt                 
   283: |||            xyzf_QMix(:,:,:,IdxNH3)    = xyz_QMixNH3_nxt   - xyzf_QMixBZ(:,:,:,IdxNH3)
   284: |||            xyzf_QMix(:,:,:,IdxH2S)    = xyz_QMixH2S_nxt   - xyzf_QMixBZ(:,:,:,IdxH2S)
   285: **V----        xyzf_QMix(:,:,:,IdxNH4SHc) = xyz_QMixNH4SH_nxt - xyzf_QMixBZ(:,:,:,IdxNH4SHc)
   286:                
   287:              end subroutine MoistAdjustNH4SH
   288:            
   289:              
   290:            end Module MoistAdjust
